_Text SEGMENT PUBLIC USE16
  org 0

EntryPoint:

;Currently we are at 0:7C00
;jmp far SEG:OFS
;This makes us be at 7C0:0
;db 0EAh  			
;dw AfterData, 7C0h		
jmp 0x07c0:AfterData

;Put any data here!
	BOOT_MSG db 'Welcome to WONDER LAND!',10,13,0
	ACTIVITY db '. ',0
	
	ReadSuccess DB 'Disk read success',10,13,0
    ReadFailure DB 'Disk read failure',10,13,0

    UnknownFileSystem DB 'Error : Unknown file system!',10,13,0
    Ext2FileSystem DB 'Ext2 file system detected!',10,13,0

    RSuper DB 'Attempting to read in the super block...',10,13,0
    RGroup DB 'Reading in group desc table...',10,13,0
    RINode DB 'Reading in i-node table...',10,13,0

	noOfSectors    db 0x01
	absoluteSector db 0x01
	absoluteHead   db 0x00
	absoluteTrack  db 0x00
	DriveNumber    db 0x00
	BlockSize	   db 2


AfterData:

; update DS to be 7C0 instead of 0
  push	  CS
  pop     DS

; update ES also
  push	  CS
  pop     ES


; create stack
  mov     ax, 0x0000
  mov     ss, ax
  mov     sp, 0xFFFF

; display boot message...
  lea si, [BOOT_MSG]
  call Print

; Setting up the location for the sector data
;   that will be read in...
    mov     bx, Sectdata

; Reading the super block...
    lea si, [RSuper]
    call Print

    mov     BYTE[absoluteSector], 3
    call    ReadSectors

; Does this disk contain the ext2 filesystem?
CheckFileSystem:
    mov     ax, [Sectdata+56]
    cmp     ax, 0xEF53
    jz      .Ext2FileSystem
.UnknownFileSystem:
    lea     si, [UnknownFileSystem]
    call    Print
    jmp     DIE_LOOP
.Ext2FileSystem:
    lea     si, [Ext2FileSystem]
    call    Print
.endCheckFileSystem:

; Determine the block size...
    mov     cx, WORD[Sectdata+24]
    sal     BYTE[BlockSize], cl

; Reading the group descriptor block...
    lea si, [RGroup]
    call Print
    mov     BYTE[absoluteSector], 5
    call    ReadSectors

; Reading the i-node table...
    lea si, [RINode]
    call Print
    mov     ax, [Sectdata+8] ;i-node table's block no is at offset 8
    add     ax, ax
    add     ax, 2       ; Boot inode (No. 5)
    mov     BYTE[absoluteSector], al
    call    ReadSectors

; Reading in the file...
    mov     si, Sectdata;    I-Node 5 - the boot I-Node
    ;    Getting the file size at offset 4
    mov     ax, [si+4]
    mov     dx, 0
    mov     cx, 512
    div     cx
    add     ax, 1
    ;    mov     BYTE[InitFileSize], ax
    mov     BYTE[noOfSectors], al
    ;  Getting the location of the init file
    mov     ax, [si+40]
    add     ax, ax
    mov     cl, 18
    div     cl
    add     ah, 1
    mov     BYTE[absoluteSector], ah   ;    Sector No
    mov     cl, al
    and     cl, 1
    mov     BYTE[absoluteHead], cl     ;    Side No
    mov     ah, 0
    mov     cl, 2
    div     cl
    mov     BYTE[absoluteTrack], al    ;    Track No
    mov     bx, 0x7E0
    mov     es, bx
    mov     bx, 0
    call    ReadSectors

; Transfer control to Init...
    jmp 0x07E0:0
;	Display file Init...
;    mov     si, Sectdata;
;    call    Print


; Go into a hang printing dots
DIE_LOOP:
  lea si, [ACTIVITY]
  call Print
      mov cx, 0xffff
      delay1:
         mov bx, 0xfff
         delay2:
         dec bx
         jnz delay2
      dec cx
      jnz delay1
  jmp DIE_LOOP


;************************************************************
;	Procedure Read Sectors
;	reads cx sectors from disk starting at ax into
;	memory location es:bx
;************************************************************

     ReadSectors:
          mov     ah, 0x02                            ; BIOS read sector
          mov     al, BYTE [noOfSectors]              ; No of sectors to read
          mov     ch, BYTE [absoluteTrack]            ; track
          mov     cl, BYTE [absoluteSector]           ; sector
          mov     dh, BYTE [absoluteHead]             ; head
          mov     dl, BYTE [DriveNumber]              ; drive
          int     0x13                                ; invoke BIOS
          jc     .FAILURE                             ; test for read error
     .SUCCESS:
	  lea si, [ReadSuccess]
	  call Print
	  ret

     .FAILURE:
	  lea si, [ReadFailure]
	  call Print
          ret
;   End of procedure ReadSector

;************************************************************
;	Procedure print
;	prints a zero terminated string pointed to by si
;************************************************************
Print:
    push ax
    mov ah, 14     ;    BIOS code for screen display
    cld
print_loop:
    lodsb          ;    moving the character to be displayed to al
    or al, al      ;    checking if the char is NULL
    jz printdone
    int 10h        ;    Calling BIOS routine
    JMP print_loop

printdone:
    pop ax
    ret
;   End of print procedure...

	
; Make the file 512 bytes long
  TIMES   510-($-$$) DB 0		

; Add the boot signature
  dw 0AA55h

Sectdata: